summaryrefslogtreecommitdiffstats
path: root/board
diff options
context:
space:
mode:
authorCarlo Caione <carlo.caione@gmail.com>2013-05-26 12:08:23 +0000
committerPeter Korsgaard <jacmet@sunsite.dk>2013-05-29 12:52:53 +0200
commit3496b8b5c81ca2368520f48c58f55edde61ffa15 (patch)
tree100f2f073e00880cb7ada6d4695d85ab4510cf8c /board
parent316f991729c423c9a49a955d3747ff31ad7a0068 (diff)
downloadbuildroot-novena-3496b8b5c81ca2368520f48c58f55edde61ffa15.tar.gz
buildroot-novena-3496b8b5c81ca2368520f48c58f55edde61ffa15.zip
cubieboard: add support
[Peter: adjust for _FEX_FILE] Signed-off-by: Carlo Caione <carlo.caione@gmail.com> Signed-off-by: Thomas Petazzoni <thomas.petazzoni@free-electrons.com> Signed-off-by: Peter Korsgaard <jacmet@sunsite.dk>
Diffstat (limited to 'board')
-rw-r--r--board/cubietech/cubieboard/boot.cmd4
-rwxr-xr-xboard/cubietech/cubieboard/mkcubiecard.sh119
-rwxr-xr-xboard/cubietech/cubieboard/post-build.sh14
-rw-r--r--board/cubietech/cubieboard/readme.txt59
4 files changed, 196 insertions, 0 deletions
diff --git a/board/cubietech/cubieboard/boot.cmd b/board/cubietech/cubieboard/boot.cmd
new file mode 100644
index 000000000..849ed0071
--- /dev/null
+++ b/board/cubietech/cubieboard/boot.cmd
@@ -0,0 +1,4 @@
+setenv bootargs console=ttyS0,115200 root=/dev/mmcblk0p2 rootwait panic=10 ${extra}
+fatload mmc 0 0x43000000 script.bin
+fatload mmc 0 0x48000000 uImage
+bootm 0x48000000
diff --git a/board/cubietech/cubieboard/mkcubiecard.sh b/board/cubietech/cubieboard/mkcubiecard.sh
new file mode 100755
index 000000000..4ffb22304
--- /dev/null
+++ b/board/cubietech/cubieboard/mkcubiecard.sh
@@ -0,0 +1,119 @@
+#! /bin/sh
+# mkCubieCard.sh v0.1:
+# 2013, Carlo Caione <carlo.caione@gmail.com>
+# heavely based on :
+# mkA10card.sh v0.1
+# 2012, Jason Plum <jplum@archlinuxarm.org>
+# loosely based on :
+# mkcard.sh v0.5
+# (c) Copyright 2009 Graeme Gregory <dp@xora.org.uk>
+# Licensed under terms of GPLv2
+#
+# Parts of the procudure base on the work of Denys Dmytriyenko
+# http://wiki.omap.com/index.php/MMC_Boot_Format
+
+IMAGES_DIR=$1
+SPL_IMG=$IMAGES_DIR/sunxi-spl.bin
+UBOOT_IMG=$IMAGES_DIR/u-boot.bin
+UIMAGE=$IMAGES_DIR/uImage
+BIN_BOARD_FILE=$IMAGES_DIR/script.bin
+ROOTFS=$IMAGES_DIR/rootfs.tar
+BOOT_CMD_H=$IMAGES_DIR/boot.scr
+
+export LC_ALL=C
+
+if [ $# -ne 2 ]; then
+ echo "Usage: $0 <images_dir> <drive>"
+ exit 1;
+fi
+
+if [ $EUID -ne 0 ]; then
+ echo "This script must be run as root" 1>&2
+ exit 1
+fi
+
+if [ ! -f $SPL_IMG ] ||
+ [ ! -f $UBOOT_IMG ] ||
+ [ ! -f $UIMAGE ] ||
+ [ ! -f $BIN_BOARD_FILE ] ||
+ [ ! -f $ROOTFS ] ||
+ [ ! -f $BOOT_CMD_H ]; then
+ echo "File(s) missing."
+ exit 1
+fi
+
+DRIVE=$2
+P1=`mktemp -d`
+P2=`mktemp -d`
+
+dd if=/dev/zero of=$DRIVE bs=1M count=3
+
+SIZE=`fdisk -l $DRIVE | grep Disk | grep bytes | awk '{print $5}'`
+
+echo DISK SIZE - $SIZE bytes
+
+
+# ~2048, 16MB, FAT, bootable
+# ~rest of drive, Ext4
+{
+echo 32,512,0x0C,*
+echo 544,,,-
+} | sfdisk -D $DRIVE
+
+sleep 1
+
+if [ -b ${DRIVE}1 ]; then
+ D1=${DRIVE}1
+ umount ${DRIVE}1
+ mkfs.vfat -n "boot" ${DRIVE}1
+else
+ if [ -b ${DRIVE}p1 ]; then
+ D1=${DRIVE}p1
+ umount ${DRIVE}p1
+ mkfs.vfat -n "boot" ${DRIVE}p1
+ else
+ echo "Cant find boot partition in /dev"
+ exit 1
+ fi
+fi
+
+
+if [ -b ${DRIVE}2 ]; then
+ D2=${DRIVE}2
+ umount ${DRIVE}2
+ mkfs.ext4 -L "Cubie" ${DRIVE}2
+else
+ if [ -b ${DRIVE}p2 ]; then
+ D2=${DRIVE}p2
+ umount ${DRIVE}p2
+ mkfs.ext4 -L "Cubie" ${DRIVE}p2
+ else
+ echo "Cant find rootfs partition in /dev"
+ exit 1
+ fi
+fi
+
+mount $D1 $P1
+mount $D2 $P2
+
+# write uImage
+cp $UIMAGE $P1
+# write board file
+cp $BIN_BOARD_FILE $P1
+# write u-boot script
+cp $BOOT_CMD_H $P1
+# write rootfs
+tar -C $P2 -xvf $ROOTFS
+
+sync
+
+umount $D1
+umount $D2
+
+rm -fr $P1
+rm -fr $P2
+
+# write SPL
+dd if=$SPL_IMG of=$DRIVE bs=1024 seek=8
+# write mele u-boot
+dd if=$UBOOT_IMG of=$DRIVE bs=1024 seek=32
diff --git a/board/cubietech/cubieboard/post-build.sh b/board/cubietech/cubieboard/post-build.sh
new file mode 100755
index 000000000..1b0258c55
--- /dev/null
+++ b/board/cubietech/cubieboard/post-build.sh
@@ -0,0 +1,14 @@
+#!/bin/sh
+# post-build.sh for CubieBoard
+# 2013, Carlo Caione <carlo.caione@gmail.com>
+
+BOARD_DIR="$(dirname $0)"
+MKIMAGE=$HOST_DIR/usr/bin/mkimage
+BOOT_CMD=$BOARD_DIR/boot.cmd
+BOOT_CMD_H=$BINARIES_DIR/boot.scr
+
+# U-Boot script
+if [ -e $MKIMAGE -a -e $BOOT_CMD ];
+then
+ $MKIMAGE -C none -A arm -T script -d $BOOT_CMD $BOOT_CMD_H
+fi
diff --git a/board/cubietech/cubieboard/readme.txt b/board/cubietech/cubieboard/readme.txt
new file mode 100644
index 000000000..1c4711767
--- /dev/null
+++ b/board/cubietech/cubieboard/readme.txt
@@ -0,0 +1,59 @@
+cubieboard
+
+-----
+Intro
+-----
+
+To be able to use your cubieboard board with the images generated by
+Buildroot you have to correctly setup the SD card.
+
+For more information, please see http://linux-sunxi.org/FirstSteps
+
+---------------
+How to build it
+---------------
+
+You need to use the cubieboard_defconfig, to do so:
+ * make cubieboard_defconfig
+
+And to compile:
+ * make
+
+-----------------
+What is generated
+-----------------
+
+After building, you should obtain this tree:
+
+ output/images/
+ +-- rootfs.tar
+ +-- boot.scr
+ +-- script.bin
+ +-- sunxi-spl.bin
+ +-- u-boot.bin
+ `-- uImage
+
+--------------------------
+How setting up the SD card
+--------------------------
+
+Depending on the rootfs size, you might want to use a 2GB or larger SD-card.
+The script mkcubiecard.sh will take care of partitioning and formatting
+the SD-card.
+
+BEWARE! This process will erase your SD card.
+
+Use dmesg to find out where the SD card is attached in the /dev tree
+(<device>) and then:
+
+# sudo ./mkcubiecard.sh <images_dir> <device>
+
+where:
+ - <images_dir> is the directory containing the generated files (usually
+ output/images)
+ - <device> is the device file of the SD card (usually /dev/sdX)
+
+
+
+--
+Carlo Caione <carlo.caione@gmail.com>